# Typescript SDK

### Objective

This SDK is designed to make it easy for you to use the bloXroute Labs API in Typescript.&#x20;

This library is exposes HTTP, websockets, and GRPC interfaces, and is compatible with both modern browser and node.js environments. Note that some methods and the GRPC interface is only available in node.js run-times, since some aspects of these functions are incompatible with browsers (e.g. http/2 requirement for GRPC, loading from environment, etc.)

[Source](https://github.com/bloXroute-Labs/serum-client-ts)

### Installation

```
$ npm install @bloxroute/solana-trader-client-ts
```

### Usage

First, you will need an `AUTH_HEADER` from bloXroute (see [the BDN user portal](https://portal.bloxroute.com/)) . If you wish to create transactions you will also need your Solana `PRIVATE_KEY` available.

In `node.js` environments, you can specify both of these values in a `.env` file, or export them manually yourself. In the browser, you'll want to define them during run-time from user input, and probably use some wallet provider to handle the transaction signing.

A simple example:

```typescript
import {
    MAINNET_API_GRPC_PORT,
    MAINNET_API_NY_GRPC,
    GrpcProvider,
    GetRecentBlockHashRequest,
    loadFromEnv
} from "@bloxroute/solana-trader-client-ts";

// Calls to provider must be made inside async function
async function main(): Promise<void> {
    try {
        // Load configuration from environment variables
        const config = loadFromEnv();

        // Initialize the GrpcProvider with necessary credentials and endpoint
        const provider = new GrpcProvider(
            config.authHeader,
            config.privateKey,
            `${MAINNET_API_NY_GRPC}:${MAINNET_API_GRPC_PORT}`,
            true
        );

        // Prepare the request for fetching the recent block hash
        const request: GetRecentBlockHashRequest = {};

        // Fetch the recent block hash from the provider
        const response = await provider.getRecentBlockHash(request);

        // Log the response
        console.info("Recent Block Hash Response: ");
        console.info(JSON.stringify(response, null, 2));
    } catch (error) {
        console.error("Error fetching recent block hash:", error);
    }
}

// Execute the main function
main();
```

Refer to the `examples/` for more info. As mentioned above, you'll need an `.env` file for exported variables to execute the full suite. A proper `.env` file looks like something like this.

```
AUTH_HEADER="ZDIxYzE0NmItZWYxNi00ZmFmLTg5YWUtMzYwMTk4YzUyZmM4OjEwOWE5MzEzZDc2Yjg3M......................"
PRIVATE_KEY="3EhZ4Epe6QrcDKQRucdftv6vWXMnpTKDV4mekSPWZEcZnJV4huzesLHwASdVUzo......................"
```

A general note on transaction submission: methods named `post*` (e.g. `postOrder`) typically do not sign/submit the transaction, only return the raw unsigned transaction. This is mainly useful for generating transaction in browsers or if you want to handle your signing manually. You may also want to use the similarly named `submit*` methods (e.g. `submitOrder`), which generate, sign, and submit the transaction all at once.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.bloxroute.com/solana/trader-api/quick-start/typescript-sdk.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
